xfsqa: build dbtest on debian platforms
[xfstests-dev.git] / 112
1 #! /bin/bash
2 # FS QA Test No. 112
3 #
4 # fsx (AIO variant, based on 075)
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2005 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24 # creator
25 owner=nathans@sgi.com
26
27 seq=`basename $0`
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=0        # success is the default!
33 trap "_cleanup; exit \$status" 0 1 2 3 15
34
35 _cleanup()
36 {
37     cd /
38     rm -rf $testdir/fsx.* $tmp.*
39     _cleanup_testdir
40 }
41
42 # get standard environment, filters and checks
43 . ./common.rc
44 . ./common.filter
45
46 _do_test()
47 {
48     _n="$1"
49     _param="$2"
50
51     out=$testdir/fsx
52     rm -rf $out
53     if ! mkdir $out
54     then
55         echo "    failed to mkdir $out"
56         status=1
57         exit
58     fi
59
60     _filter_param=`echo "$_param" | sed\
61         -e 's/-N [0-9][0-9]*/-N numops/' \
62         -e 's/-l [0-9][0-9]*/-l filelen/'`
63
64     echo ""
65     echo "-----------------------------------------------"
66     echo "fsx.$_n : $_filter_param"
67     echo "-----------------------------------------------"
68
69     if [ "$FSTYP" != "xfs" ]
70     then
71         if [ "$_n" = "1" -o "$_n" = "3" ]
72         then
73             # HACK: only xfs handles preallocation (-x) so just skip this test
74             return
75         fi
76     fi
77
78     # This cd and use of -P gets full debug on $here (not TEST_DEV)
79     cd $out
80     if ! $here/ltp/fsx $_param -P $here $seq.$_n >/dev/null
81     then
82         echo "    fsx ($_param) returned $? - see $seq.$_n.full"
83         mv $seq.$_n.fsxlog $here/$seq.$_n.full
84         status=1
85         exit
86     fi
87
88     cd $here
89     _check_test_fs
90 }
91
92 _usage()
93 {
94     echo "$0: [-l filelen] [-n numops1] [-N numops2]"
95 }
96
97 _process_args()
98 {
99     while getopts "l:n:N:?" c $@
100     do
101         case $c
102         in
103             l)
104                 filelen=$OPTARG
105                 param_type="$param_type, overidde -l"
106                 ;;
107             N)
108                 numops2=$OPTARG
109                 param_type="$param_type, overidde -N"
110                 ;;
111             n)
112                 numops1=$OPTARG
113                 param_type="$param_type, overidde -n"
114                 ;;
115             ?)
116                 _usage
117                 exit    
118                 ;;
119         esac
120     done
121 }
122
123
124 # real QA test starts here
125 _supported_fs generic
126 _supported_os Linux
127
128 [ -x $here/ltp/aio-stress ] || \
129         _notrun "fsx not built with AIO for this platform"
130
131 size10=`expr 10 \* 1024 \* 1024`        # 10 megabytes
132 filelen=$size10
133 numops1=1000
134 numops2=10000
135
136 # can override the params here
137 _process_args "$@"
138
139 echo "Params are for $param_type" >>$seq.full
140 echo "Params: n = $numops1 N = $numops2 l = $filelen" >>$seq.full
141
142 _setup_testdir
143
144 rm -f $here/$seq.full
145 echo "brevity is wit..."
146
147 _check_test_fs
148
149 # Options:
150 # -d: debug output for all operations
151 # -l flen: the upper bound on file size (default 262144)
152 # -o oplen: the upper bound on operation size
153 # -N numops: total # operations to do (default infinity)
154 # -P: save .fsxlog and .fsxgood files in dirpath (default ./)
155 # -S seed: for random # generator (default 1) 0 gets timestamp
156 # -x: pre-allocate file space, exercising unwritten extents
157 # -A: use the AIO system calls
158
159 _do_test 0 "-A -d -N $numops1 -S 0"
160 _do_test 1 "-A -d -N $numops1 -S 0 -x"
161 _do_test 2 "-A -d -N $numops2 -l $filelen -S 0"
162 _do_test 3 "-A -d -N $numops2 -l $filelen -S 0 -x"
163
164 rm -f $seq.*.fsx{good,log}
165 exit 0